VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsBLog"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Public file_name$
Public Exceptions$

  '  Currently available format is:
  ' 
  '  Item_name [As] [Type] ['[Caption][<=>|<|>Default_data]CRLF
  '            Type - type of variable
  '            Caption - caption on Preferences Form
  '            <=>     - Default_data is a text string. 
  '                      No double quotes required.
  '            <|>     - VB expression which be assigned to default data.
  ' 
  '  Strings <Type ...> and <End> are not required.
  '  
  '  Comments are allowed between lines.
  '  Key sequence "end tab" marks end of controls on tab.
  '      To work as designed, to separate tabs,
  '      no spacers are allowed between "end tab" and [CR]LF.
  '  Running test on this source helps to understand more details.
  ' General Settings
Public ReportDay As date
Public ReportTime As date
Public ReportPeriod As Long
Public PriPhone As String
Public UseTcpIp As boolean
Public ModemUsed As Boolean
Public AllowEmail As boolean
  ' Modem Settings
Public AltPhone As String
Public DialAttempts As Integer
Public DialDelay As Integer
Public DialConnectTo As Integer
Public ConnectTimeout As Integer
Public ModemPort As Integer
Public ConnectRetries As integer
  ' Advanced Modem
Public ModemSettings As Variant
Public InitStrings As String
Public SuccessStrings As String
Public FailStrings As String
Public TerminateStrings As String
Public UseDTR As Boolean
Public Handshake As String
  '  TCP/IP Settings
Public TcpConnectTO As Integer
Public NumSockets As Integer
Public HostAddress As String
Public HostIp As String
Public HostPort As Integer
  '  EMail Settings
Public EmailSomeAddress As Boolean
Public SmtpAddress As String
Public SmtpPort As Integer
Public EmailFrom As String
Public EmailAddHours As Integer



Private sub Class_Initialize()
  dim ws$

  file_name = _
       App.Path & "\" & "BLog_preferences.dat"
  ws = read_me()
  if "" <> ws then msgbox ws
  if "Missed" = left(Exceptions, 6) then
     'no exception handling for defaults
     'assuming that programmer is careful:
        ReportDay =  date$
   ReportTime = " 02:00:00 AM"
   ReportPeriod = " 7 "
   UseTcpIp = "False"
   ModemUsed = "False"
   AllowEmail = "False"
   NumSockets = "1"
   HostAddress = "somedomain.com"



  end if

  Validate
  
End Sub

Public Sub Validate() 


end sub

'=============================
'  save preferences
'-----------------------------
public function write_me()
  dim L&, s$
  dim h% '=file handler

  'clear exception state:
  Exceptions = ""
  on error goto he
  h = FreeFile
  Open file_Name For Binary Shared As #h

 s=cstr(ReportDay) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(ReportTime) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(ReportPeriod) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(PriPhone) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(UseTcpIp) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(ModemUsed) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(AllowEmail) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(AltPhone) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(DialAttempts) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(DialDelay) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(DialConnectTo) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(ConnectTimeout) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(ModemPort) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(ConnectRetries) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(ModemSettings) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(InitStrings) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(SuccessStrings) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(FailStrings) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(TerminateStrings) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(UseDTR) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(Handshake) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(TcpConnectTO) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(NumSockets) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(HostAddress) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(HostIp) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(HostPort) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(EmailSomeAddress) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(SmtpAddress) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(SmtpPort) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(EmailFrom) : l=len(s) :  put h,,l :  put h,,s
 s=cstr(EmailAddHours) : l=len(s) :  put h,,l :  put h,,s

  
  close h
  'clear exception state:
  exit function

he:  s = "Exception " & _
         Cstr(Err.Number) & " " & _
         Err.description & vbcrlf & _
         "when writing to file:" & vbcrlf & _
         file_name
     resume xHe
xHe: write_me = s
     Exceptions = s

end function
  
'=============================
'  read preferences
'-----------------------------
public function read_me$()
  dim L&, s$
  dim h% '=file handler
  'clear exception state:
  Exceptions = ""
  on error goto he

  if dir(file_name) = "" then 
     Exceptions = "Missed preference file: " & _
                  file_name
     exit function
  end if

  h = FreeFile
  Open file_Name For Binary Shared As #h

  get h,,l :  s=space(l) :  get h,,s :  ReportDay=CDate(s)
  get h,,l :  s=space(l) :  get h,,s :  ReportTime=CDate(s)
  get h,,l :  s=space(l) :  get h,,s :  ReportPeriod=CLng(s)
  get h,,l :  s=space(l) :  get h,,s :  PriPhone=s
  get h,,l :  s=space(l) :  get h,,s :  UseTcpIp=CBool(s)
  get h,,l :  s=space(l) :  get h,,s :  ModemUsed=CBool(s)
  get h,,l :  s=space(l) :  get h,,s :  AllowEmail=CBool(s)
  get h,,l :  s=space(l) :  get h,,s :  AltPhone=s
  get h,,l :  s=space(l) :  get h,,s :  DialAttempts=CInt(s)
  get h,,l :  s=space(l) :  get h,,s :  DialDelay=CInt(s)
  get h,,l :  s=space(l) :  get h,,s :  DialConnectTo=CInt(s)
  get h,,l :  s=space(l) :  get h,,s :  ConnectTimeout=CInt(s)
  get h,,l :  s=space(l) :  get h,,s :  ModemPort=CInt(s)
  get h,,l :  s=space(l) :  get h,,s :  ConnectRetries=CInt(s)
  get h,,l :  s=space(l) :  get h,,s :  ModemSettings=s
  get h,,l :  s=space(l) :  get h,,s :  InitStrings=s
  get h,,l :  s=space(l) :  get h,,s :  SuccessStrings=s
  get h,,l :  s=space(l) :  get h,,s :  FailStrings=s
  get h,,l :  s=space(l) :  get h,,s :  TerminateStrings=s
  get h,,l :  s=space(l) :  get h,,s :  UseDTR=CBool(s)
  get h,,l :  s=space(l) :  get h,,s :  Handshake=s
  get h,,l :  s=space(l) :  get h,,s :  TcpConnectTO=CInt(s)
  get h,,l :  s=space(l) :  get h,,s :  NumSockets=CInt(s)
  get h,,l :  s=space(l) :  get h,,s :  HostAddress=s
  get h,,l :  s=space(l) :  get h,,s :  HostIp=s
  get h,,l :  s=space(l) :  get h,,s :  HostPort=CInt(s)
  get h,,l :  s=space(l) :  get h,,s :  EmailSomeAddress=CBool(s)
  get h,,l :  s=space(l) :  get h,,s :  SmtpAddress=s
  get h,,l :  s=space(l) :  get h,,s :  SmtpPort=CInt(s)
  get h,,l :  s=space(l) :  get h,,s :  EmailFrom=s
  get h,,l :  s=space(l) :  get h,,s :  EmailAddHours=CInt(s)

  
  close h
 
  exit function
he:  s = "Exception " & _
         Cstr(Err.Number) & " " & _
         Err.description & vbcrlf & _
         "when reading file:" & vbcrlf & _
         file_name & vbcrlf & _
         "approximately at value: " & _
         left(s, 100)
     resume xHe
xHe: read_me = s    
     Exceptions = s

end function