VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "REPLACEME1"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
Option Explicit

Private ve$, vr$, vl$
Private SessionCallNumber&
Private IgnoreInputProperties As Boolean


'DESC Template for case if programmer
'     needs to be sure that none of timers
'     in form is running when terminating Dll.
'
Public Function TimersCompleted( _
       StatusBarMessage, WaitInterval)
    Dim Threshold&
    Threshold = GetTickCount + WaitInterval
    Do While Threshold > GetTickCount
       DoEvents
    Loop
    
    web_d "StatusBarMessage = " & _
        web_StatusBarMessage
    StatusBarMessage = web_StatusBarMessage

    TimersCompleted = web_TimersCompleted
    web_d "TimersCompleted=" & _
          web_TimersCompleted
End Function





Private Sub Class_Initialize()

ve = vbCrLf
vr = vbCr
vl = vbLf

SessionCallNumber = 0
web_AllowLocal = "W"

web_d "Initializing """ & App.Title & _
      """ Web Interface Class."

ReDim web_ZO(0)
ReDim web_OZ(0)

End Sub


'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
'CLASS WICH PROVIDES AN INTERFACE TO DLL
'- - ------------------------------------------------------
'     This class must be included in the dll.
'     If this class name ""InterfaceToDll"",
'     conflicts with already existing name,
'     correspondind changes should be made.
'========================================================
'
'================================================
'DESC sets properties changed by Web Browser
'     fires events    fired   by Web Browser
'     gets properties changed by VB  Application
'INPUT AND OUTPUT parameters:
'     app_terminated
'
'INPU p - array of properties, e - event
'OUTP p - array of properties
'     msg - zero-based array of 6 elements
'           msg(0) = 1 => message box happened
'                  = 0    no message
'Fatal exception is indicated by ExchangeData <> ""
'      in this case ExchangeData contains message
'
'invalid_session <> "" if session was unexpectably reset
'        invalid_session is a message in this case
'
'
'------------------------------------------------
Public Function ExchangeData(p, e, _
       session_call_number, _
       sessionID, _
       invalid_session, _
       msg, app_terminated, _
       ignore_input_properties, _
       trace_application, _
       AllowLocal, TimersPreventDestroying, _
       LetTimerComplete, _
       StatusBarMessage, ZO, OZ)

Dim ws$, w_invalid_session$, w_session_number&
Dim n&, I&

OZ(0) = 0 'means nothing is in ZO,OZ arrays

'=================================================
' Debugging.
'-------------------------------------------------
'set trace_application = false
'if security is concern:
If trace_application Then
   web_c.TraceApplication = True
End If
   
ws = _
   "ExchangeData called: Parameters are:" & ve & _
   "  Session Visit=" & _
           session_call_number & ve & _
   "  Session ID=" & sessionID & ve & _
   "  Event Number=" & CStr(e) & ve & _
   "  ignore_input_properties=" & _
           ignore_input_properties & ve
ws = ws & _
   "  AllowLocal=" & AllowLocal & ve & _
   "  web_OriginalStartUpDone=" & ve & _
   web_OriginalStartUpDone & ve & _
   "application_terminated = " & _
    app_terminated & ve & _
   "TimersPreventDestroying=" & _
   TimersPreventDestroying & ve & _
   "LetTimerComplete=" & LetTimerComplete
web_d ws
   
'=================================================
ws = Trim(CStr(sessionID))

If "" = ws Or _
   ("" <> web_SID And web_SID <> ws) Then
   
   'I don't think
   ' web_SID <> ws is possible:
   ' but beeing paranoid, I include this
   ' in provide the handler:

   invalid_session = "SessionID is invalid." & _
        "Perhaps the browser " & _
        "does not supports cookies or runs on PWS."
   web_d CStr(invalid_session)
   Exit Function
End If

If app_terminated Then GoTo TerminateAndExit

web_AllowLocal = AllowLocal


If "Y" <> web_OriginalStartUpDone Then
  web_SID = CStr(sessionID)
  'Make Startup:
    
',#]REPLACEME3
  web_OriginalStartUpDone = "Y"
End If


web_MsgCalled = 0
If msg(0) <> 0 Then
   web_ResponseToMsgBoxTo = msg(0)
End If

invalid_session = ""

w_invalid_session = "Session Visit Number '" & _
   session_call_number & "' is invalid: " & _
   "number " & SessionCallNumber & " is expected."
   
   
   '& ve & _
   '"The data submitted from the Web Browser are ignored." & _
   '"Please be sure that cookies are enabled, you called from correct page browser is set correctly, " & _
   '"web page is not form outdated cache, or restart the Application."

On Error Resume Next

' check for session garbage --------------->
If "" = Trim(session_call_number) Then
   invalid_session = w_invalid_session
End If
   
w_session_number = CLng(session_call_number)
If Err.Number > 0 Then
   invalid_session = w_invalid_session
End If

If w_session_number < 0 Then
   invalid_session = w_invalid_session
End If
' check for session garbage ---------------<


If w_session_number > SessionCallNumber Then
  
  If 0 = SessionCallNumber Then
     invalid_session = w_invalid_session & ve & _
     "Your browser may not support cookies " _
     & " or your session may be expired."
  Else
     invalid_session = w_invalid_session & ve & _
       "Perhaps you called from " & _
       "page cached in previous session. "
  End If
  
ElseIf w_session_number < SessionCallNumber Then
     
     invalid_session = w_invalid_session & ve & _
     "Perhaps you called from cached page."

End If


If "" <> invalid_session Then
   ignore_input_properties = True
   'return to Browser current properties'
   'ignore event:
   e = -1
End If

SessionCallNumber = SessionCallNumber + 1
'Hope this never happens:
If 2000000000 < SessionCallNumber Then
   SessionCallNumber = 1
End If

session_call_number = CStr(SessionCallNumber)

On Error GoTo he

mic_BuildLoadedForms

'this variable may take an effect only
'in converted project:
IgnoreInputProperties = ignore_input_properties

web_d "Setting/getting data to/from dll:"
',#]REPLACEME2

'loaded_forms = web_LoadedForms
n = UBound(web_OZ)
If 0 < n Then
  'loaded_forms = web_LoadedForms
  For I = 1 To n
      OZ(I) = web_OZ(I)
  Next
  OZ(0) = n
  n = UBound(web_ZO)
  For I = 1 To n
      ZO(I) = web_ZO(I)
  Next
End If
web_ZOChangedAtServer = False

app_terminated = 0
If web_InformTerminationToClient Then
   web_MsgMessage = web_MsgMessage & ve & _
      "Application is Terminating ..." & ve
   GoTo TerminateAndExit
End If

If 0 < web_MsgCalled Then
   web_d "Msg box is called:" & web_MsgMessage
   msg(0) = web_MsgCalled
   msg(1) = web_MsgMessage
   msg(2) = CStr(web_MsgButtons)
   msg(3) = web_MsgTitle
   msg(4) = web_MsgHelpFile
   msg(5) = CStr(web_MsgContext)
   msg(6) = web_MsgButtonsMissed
   msg(7) = web_MsgTitleMissed
   msg(8) = web_MsgHelpfileMissed
   web_MsgCalled = 0
   web_MsgMessage = ""
   web_MsgButtons = 0
   web_MsgTitle = ""
   web_MsgHelpFile = ""
   web_MsgContext = 0
End If

LetTimerComplete = web_TimersCompleted
web_d "TimersCompleted=" & _
          web_TimersCompleted
StatusBarMessage = web_StatusBarMessage
web_MsgMessage = ""

Exit Function

TerminateAndExit:
  'Two this variables control shutdown:

     TimersPreventDestroying = Destroy_IfNoTimers
     app_terminated = -1

  msg(0) = 1
  msg(1) = web_MsgMessage
  msg(6) = -1 'web_MsgButtonsMissed
  msg(7) = -1 'web_MsgTitleMissed
  msg(8) = -1 'web_MsgHelpfileMissed
    
  StatusBarMessage = web_StatusBarMessage
  web_d web_MsgMessage
  web_MsgMessage = ""
  Exit Function


he:
       'Construct exception message and
       'pending Application Message if any.
       web_MsgMessage = _
          "Exception " & Err.Number & " " & _
          Err.Description & ve & _
          "in ExchangeData method at event " _
          & CStr(e) & ve & _
          web_MsgMessage
      Resume xTerminateAndExit

xTerminateAndExit:
      On Error Resume Next
      GoTo TerminateAndExit

End Function


'micro helper:
Private Function mic_IsLoaded(FrmName$) As Boolean
 If InStr(ve & UCase(web_LoadedForms), _
          ve & UCase(FrmName) & ve) > 0 Then
    mic_IsLoaded = True
 Else
    mic_IsLoaded = False
 End If
End Function

Private Sub Class_Terminate()
 
 web_d "Terminating """ & App.Title & _
       """ DllInterface Class."
 
 'to allow Web Server "graciously"
 'terminate expired Session.
 'if some forms are still loaded:
 'unloade them:
 '
 'if Class_Terminate called before
 'session is expired, then
 'this is because of exception or
 'by normal termination;
 'in normal termination, all forms
 '   must be already unloaded;
 'in case of exception: try to unloade them
 '   forcefully:
 web_FormsUnloading = "F"
 web_DestroyAllForms
 
 If Not web_c Is Nothing Then
    If "Y" = web_c.IAmLoaded Then
       Unload web_c
    End If
    Set web_c = Nothing
 End If

End Sub


