VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "InterfaceToDll"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
Option Explicit

Private ve$, vr$, vl$
Private SessionCallNumber&
Private IgnoreInputProperties As Boolean


'DESC Template for case if programmer
'     needs to be sure that none of timers
'     in form is running when terminating Dll.
'
Public Function TimersCompleted( _
       StatusBarMessage, WaitInterval)
    Dim Threshold&
    Threshold = GetTickCount + WaitInterval
    Do While Threshold > GetTickCount
       DoEvents
    Loop
    
    web_d "StatusBarMessage = " & _
        web_StatusBarMessage
    StatusBarMessage = web_StatusBarMessage

    TimersCompleted = web_TimersCompleted
    web_d "TimersCompleted=" & _
          web_TimersCompleted
End Function





Private Sub Class_Initialize()

ve = vbCrLf
vr = vbCr
vl = vbLf

SessionCallNumber = 0
web_AllowLocal = "W"

web_d "Initializing """ & App.Title & _
      """ Web Interface Class."

ReDim web_ZO(0)
ReDim web_OZ(0)

End Sub


'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
'CLASS WICH PROVIDES AN INTERFACE TO DLL
'- - ------------------------------------------------------
'     This class must be included in the dll.
'     If this class name ""InterfaceToDll"",
'     conflicts with already existing name,
'     correspondind changes should be made.
'========================================================
'
'================================================
'DESC sets properties changed by Web Browser
'     fires events    fired   by Web Browser
'     gets properties changed by VB  Application
'INPUT AND OUTPUT parameters:
'     app_terminated
'
'INPU p - array of properties, e - event
'OUTP p - array of properties
'     msg - zero-based array of 6 elements
'           msg(0) = 1 => message box happened
'                  = 0    no message
'Fatal exception is indicated by ExchangeData <> ""
'      in this case ExchangeData contains message
'
'invalid_session <> "" if session was unexpectably reset
'        invalid_session is a message in this case
'
'
'------------------------------------------------
Public Function ExchangeData(p, e, _
       session_call_number, _
       sessionID, _
       invalid_session, _
       msg, app_terminated, _
       ignore_input_properties, _
       trace_application, _
       AllowLocal, TimersPreventDestroying, _
       LetTimerComplete, _
       StatusBarMessage, ZO, OZ)

Dim ws$, w_invalid_session$, w_session_number&
Dim n&, I&

OZ(0) = 0 'means nothing is in ZO,OZ arrays

'=================================================
' Debugging.
'-------------------------------------------------
'set trace_application = false
'if security is concern:
If trace_application Then
   web_c.TraceApplication = True
End If
   
ws = _
   "ExchangeData called: Parameters are:" & ve & _
   "  Session Visit=" & _
           session_call_number & ve & _
   "  Session ID=" & sessionID & ve & _
   "  Event Number=" & CStr(e) & ve & _
   "  ignore_input_properties=" & _
           ignore_input_properties & ve
ws = ws & _
   "  AllowLocal=" & AllowLocal & ve & _
   "  web_OriginalStartUpDone=" & ve & _
   web_OriginalStartUpDone & ve & _
   "application_terminated = " & _
    app_terminated & ve & _
   "TimersPreventDestroying=" & _
   TimersPreventDestroying & ve & _
   "LetTimerComplete=" & LetTimerComplete
web_d ws
   
'=================================================
ws = Trim(CStr(sessionID))

If "" = ws Or _
   ("" <> web_SID And web_SID <> ws) Then
   
   'I don't think
   ' web_SID <> ws is possible:
   ' but beeing paranoid, I include this
   ' in provide the handler:

   invalid_session = "SessionID is invalid." & _
        "Perhaps the browser " & _
        "does not supports cookies or runs on PWS."
   web_d CStr(invalid_session)
   Exit Function
End If

If app_terminated Then GoTo TerminateAndExit

web_AllowLocal = AllowLocal


If "Y" <> web_OriginalStartUpDone Then
  web_SID = CStr(sessionID)
  'Make Startup:
    
web_Main
  web_OriginalStartUpDone = "Y"
End If


web_MsgCalled = 0
If msg(0) <> 0 Then
   web_ResponseToMsgBoxTo = msg(0)
End If

invalid_session = ""

w_invalid_session = "Session Visit Number '" & _
   session_call_number & "' is invalid: " & _
   "number " & SessionCallNumber & " is expected."
   
   
   '& ve & _
   '"The data submitted from the Web Browser are ignored." & _
   '"Please be sure that cookies are enabled, you called from correct page browser is set correctly, " & _
   '"web page is not form outdated cache, or restart the Application."

On Error Resume Next

' check for session garbage --------------->
If "" = Trim(session_call_number) Then
   invalid_session = w_invalid_session
End If
   
w_session_number = CLng(session_call_number)
If Err.Number > 0 Then
   invalid_session = w_invalid_session
End If

If w_session_number < 0 Then
   invalid_session = w_invalid_session
End If
' check for session garbage ---------------<


If w_session_number > SessionCallNumber Then
  
  If 0 = SessionCallNumber Then
     invalid_session = w_invalid_session & ve & _
     "Your browser may not support cookies " _
     & " or your session may be expired."
  Else
     invalid_session = w_invalid_session & ve & _
       "Perhaps you called from " & _
       "page cached in previous session. "
  End If
  
ElseIf w_session_number < SessionCallNumber Then
     
     invalid_session = w_invalid_session & ve & _
     "Perhaps you called from cached page."

End If


If "" <> invalid_session Then
   ignore_input_properties = True
   'return to Browser current properties'
   'ignore event:
   e = -1
End If

SessionCallNumber = SessionCallNumber + 1
'Hope this never happens:
If 2000000000 < SessionCallNumber Then
   SessionCallNumber = 1
End If

session_call_number = CStr(SessionCallNumber)

On Error GoTo he

mic_BuildLoadedForms

'this variable may take an effect only
'in converted project:
IgnoreInputProperties = ignore_input_properties

web_d "Setting/getting data to/from dll:"

          If IgnoreInputProperties then GoTo SkippedInput
           cset_frmMainForm p


          If e < 0 then GoTo SkippedInput
           ceve_frmMainForm e


          SkippedInput:
          'this probably will let timers to start
          'if any:
          DoEvents

          mic_BuildLoadedForms 

          cget_frmMainForm p



'loaded_forms = web_LoadedForms
n = UBound(web_OZ)
If 0 < n Then
  'loaded_forms = web_LoadedForms
  For I = 1 To n
      OZ(I) = web_OZ(I)
  Next
  OZ(0) = n
  n = UBound(web_ZO)
  For I = 1 To n
      ZO(I) = web_ZO(I)
  Next
End If
web_ZOChangedAtServer = False

app_terminated = 0
If web_InformTerminationToClient Then
   web_MsgMessage = web_MsgMessage & ve & _
      "Application is Terminating ..." & ve
   GoTo TerminateAndExit
End If

If 0 < web_MsgCalled Then
   web_d "Msg box is called:" & web_MsgMessage
   msg(0) = web_MsgCalled
   msg(1) = web_MsgMessage
   msg(2) = CStr(web_MsgButtons)
   msg(3) = web_MsgTitle
   msg(4) = web_MsgHelpFile
   msg(5) = CStr(web_MsgContext)
   msg(6) = web_MsgButtonsMissed
   msg(7) = web_MsgTitleMissed
   msg(8) = web_MsgHelpfileMissed
   web_MsgCalled = 0
   web_MsgMessage = ""
   web_MsgButtons = 0
   web_MsgTitle = ""
   web_MsgHelpFile = ""
   web_MsgContext = 0
End If

LetTimerComplete = web_TimersCompleted
web_d "TimersCompleted=" & _
          web_TimersCompleted
StatusBarMessage = web_StatusBarMessage
web_MsgMessage = ""

Exit Function

TerminateAndExit:
  'Two this variables control shutdown:

     TimersPreventDestroying = Destroy_IfNoTimers
     app_terminated = -1

  msg(0) = 1
  msg(1) = web_MsgMessage
  msg(6) = -1 'web_MsgButtonsMissed
  msg(7) = -1 'web_MsgTitleMissed
  msg(8) = -1 'web_MsgHelpfileMissed
    
  StatusBarMessage = web_StatusBarMessage
  web_d web_MsgMessage
  web_MsgMessage = ""
  Exit Function


he:
       'Construct exception message and
       'pending Application Message if any.
       web_MsgMessage = _
          "Exception " & Err.Number & " " & _
          Err.Description & ve & _
          "in ExchangeData method at event " _
          & CStr(e) & ve & _
          web_MsgMessage
      Resume xTerminateAndExit

xTerminateAndExit:
      On Error Resume Next
      GoTo TerminateAndExit

End Function


'micro helper:
Private Function mic_IsLoaded(FrmName$) As Boolean
 If InStr(ve & UCase(web_LoadedForms), _
          ve & UCase(FrmName) & ve) > 0 Then
    mic_IsLoaded = True
 Else
    mic_IsLoaded = False
 End If
End Function

Private Sub Class_Terminate()
 
 web_d "Terminating """ & App.Title & _
       """ DllInterface Class."
 
 'to allow Web Server "graciously"
 'terminate expired Session.
 'if some forms are still loaded:
 'unloade them:
 '
 'if Class_Terminate called before
 'session is expired, then
 'this is because of exception or
 'by normal termination;
 'in normal termination, all forms
 '   must be already unloaded;
 'in case of exception: try to unloade them
 '   forcefully:
 web_FormsUnloading = "F"
 web_DestroyAllForms
 
 If Not web_c Is Nothing Then
    If "Y" = web_c.IAmLoaded Then
       Unload web_c
    End If
    Set web_c = Nothing
 End If

End Sub




'<< set properties >>
Private Sub cset_frmMainForm(p)
  If Not mic_IsLoaded("frmMainForm") then exit sub
  web_d "Setting  frmMainForm properties ... "
  With frmMainForm
   if p(21) then .optSpecial.Value = p(21)
 if not .txtSpecial.Locked then _
    .txtSpecial.Text= p(28) 
   if p(51) then .optMultiplyFist.Value = p(51)
   if p(59) then .optAddFirst.Value = p(59)
   .chkSelectHexa.Value= p(67) 
 if not .txtResult.Locked then _
    .txtResult.Text= p(74) 
 if not .txtInputD(0).Locked then _
    .txtInputD(0).Text= p(95) 
 if not .txtInputD(1).Locked then _
    .txtInputD(1).Text= p(102) 
 if not .txtInputB(0).Locked then _
    .txtInputB(0).Text= p(109) 
 if not .txtInputB(1).Locked then _
    .txtInputB(1).Text= p(116) 
 if not .txtInput(0).Locked then _
    .txtInput(0).Text= p(123) 
 if not .txtInput(1).Locked then _
    .txtInput(1).Text= p(130) 

  End With
  web_d "Properties set."
End Sub

'<< set events >>
Private Sub ceve_frmMainForm(e)
  If Not mic_IsLoaded("frmMainForm") then exit sub
  web_d "Processing event " & cstr(e) & " in frmMainForm  ... "
  With frmMainForm
    Select Case CStr(e)
      case "81": .web_cmdAdd_Click
      case "88": .web_cmdMultiply_Click
      case "179": .web_cmdEnd_Click
      case "222":   .web_mnuNew_Click
      case "231":   .web_mnuCalculator_Click
      case "240":   .web_mnuHelpMenu_Click
      case "244":   .web_mnuAbout_Click
      case "248":   .web_mnuTest_Click

    End Select
  End With
  web_d "Event processed."
End Sub



'<< get properties >>
Private Sub cget_frmMainForm(p)
  If Not mic_IsLoaded("frmMainForm") then Exit Sub
  web_d "Getting frmMainForm properties ... "
  With frmMainForm
    p(2) = web_GetFormVis(frmMainForm)
    p(3) =  .top
    p(4) =  .left
    p(5) =  .height
    p(6) =  .width
    p(8) = web_GetVis( .fraSpecials)
    p(9) =  .fraSpecials.top
    p(10) =  .fraSpecials.left
    p(11) =  .fraSpecials.height
    p(12) =  .fraSpecials.width
    p(13) =  .fraSpecials.Caption 
    p(15) = web_GetVis( .optSpecial)
    p(16) =  .optSpecial.top
    p(17) =  .optSpecial.left
    p(18) =  .optSpecial.height
    p(19) =  .optSpecial.width
    p(20) =  .optSpecial.Caption 
    p(21) =  .optSpecial.Value
    p(23) = web_GetVis( .txtSpecial)
    p(24) =  .txtSpecial.top
    p(25) =  .txtSpecial.left
    p(26) =  .txtSpecial.height
    p(27) =  .txtSpecial.width
    p(28) =  .txtSpecial.Text
    p(30) = web_GetVis( .lblSpecial)
    p(31) =  .lblSpecial.top
    p(32) =  .lblSpecial.left
    p(33) =  .lblSpecial.height
    p(34) =  .lblSpecial.width
    p(35) =  .lblSpecial.Caption 
    p(38) = web_GetVis( .fraAddMultiply)
    p(39) =  .fraAddMultiply.top
    p(40) =  .fraAddMultiply.left
    p(41) =  .fraAddMultiply.height
    p(42) =  .fraAddMultiply.width
    p(43) =  .fraAddMultiply.Caption 
    p(45) = web_GetVis( .optMultiplyFist)
    p(46) =  .optMultiplyFist.top
    p(47) =  .optMultiplyFist.left
    p(48) =  .optMultiplyFist.height
    p(49) =  .optMultiplyFist.width
    p(50) =  .optMultiplyFist.Caption 
    p(51) =  .optMultiplyFist.Value
    p(53) = web_GetVis( .optAddFirst)
    p(54) =  .optAddFirst.top
    p(55) =  .optAddFirst.left
    p(56) =  .optAddFirst.height
    p(57) =  .optAddFirst.width
    p(58) =  .optAddFirst.Caption 
    p(59) =  .optAddFirst.Value
    p(61) = web_GetVis( .chkSelectHexa)
    p(62) =  .chkSelectHexa.top
    p(63) =  .chkSelectHexa.left
    p(64) =  .chkSelectHexa.height
    p(65) =  .chkSelectHexa.width
    p(66) =  .chkSelectHexa.Caption 
    p(67) =  .chkSelectHexa.Value
    p(69) = web_GetVis( .txtResult)
    p(70) =  .txtResult.top
    p(71) =  .txtResult.left
    p(72) =  .txtResult.height
    p(73) =  .txtResult.width
    p(74) =  .txtResult.Text
    p(76) = web_GetVis( .cmdAdd)
    p(77) =  .cmdAdd.top
    p(78) =  .cmdAdd.left
    p(79) =  .cmdAdd.height
    p(80) =  .cmdAdd.width
    p(81) =  .cmdAdd.Caption 
    p(83) = web_GetVis( .cmdMultiply)
    p(84) =  .cmdMultiply.top
    p(85) =  .cmdMultiply.left
    p(86) =  .cmdMultiply.height
    p(87) =  .cmdMultiply.width
    p(88) =  .cmdMultiply.Caption 
    p(90) = web_GetVis( .txtInputD(0))
    p(91) =  .txtInputD(0).top
    p(92) =  .txtInputD(0).left
    p(93) =  .txtInputD(0).height
    p(94) =  .txtInputD(0).width
    p(95) =  .txtInputD(0).Text
    p(97) = web_GetVis( .txtInputD(1))
    p(98) =  .txtInputD(1).top
    p(99) =  .txtInputD(1).left
    p(100) =  .txtInputD(1).height
    p(101) =  .txtInputD(1).width
    p(102) =  .txtInputD(1).Text
    p(104) = web_GetVis( .txtInputB(0))
    p(105) =  .txtInputB(0).top
    p(106) =  .txtInputB(0).left
    p(107) =  .txtInputB(0).height
    p(108) =  .txtInputB(0).width
    p(109) =  .txtInputB(0).Text
    p(111) = web_GetVis( .txtInputB(1))
    p(112) =  .txtInputB(1).top
    p(113) =  .txtInputB(1).left
    p(114) =  .txtInputB(1).height
    p(115) =  .txtInputB(1).width
    p(116) =  .txtInputB(1).Text
    p(118) = web_GetVis( .txtInput(0))
    p(119) =  .txtInput(0).top
    p(120) =  .txtInput(0).left
    p(121) =  .txtInput(0).height
    p(122) =  .txtInput(0).width
    p(123) =  .txtInput(0).Text
    p(125) = web_GetVis( .txtInput(1))
    p(126) =  .txtInput(1).top
    p(127) =  .txtInput(1).left
    p(128) =  .txtInput(1).height
    p(129) =  .txtInput(1).width
    p(130) =  .txtInput(1).Text
    p(132) = web_GetVis( .Label1)
    p(133) =  .Label1.top
    p(134) =  .Label1.left
    p(135) =  .Label1.height
    p(136) =  .Label1.width
    p(137) =  .Label1.Caption 
    p(139) = web_GetVis( .Label2)
    p(140) =  .Label2.top
    p(141) =  .Label2.left
    p(142) =  .Label2.height
    p(143) =  .Label2.width
    p(144) =  .Label2.Caption 
    p(146) = web_GetVis( .Label3)
    p(147) =  .Label3.top
    p(148) =  .Label3.left
    p(149) =  .Label3.height
    p(150) =  .Label3.width
    p(151) =  .Label3.Caption 
    p(153) = web_GetVis( .lblOperand(0))
    p(154) =  .lblOperand(0).top
    p(155) =  .lblOperand(0).left
    p(156) =  .lblOperand(0).height
    p(157) =  .lblOperand(0).width
    p(158) =  .lblOperand(0).Caption 
    p(160) = web_GetVis( .lblOperand(1))
    p(161) =  .lblOperand(1).top
    p(162) =  .lblOperand(1).left
    p(163) =  .lblOperand(1).height
    p(164) =  .lblOperand(1).width
    p(165) =  .lblOperand(1).Caption 
    p(167) = web_GetVis( .lblOperand(2))
    p(168) =  .lblOperand(2).top
    p(169) =  .lblOperand(2).left
    p(170) =  .lblOperand(2).height
    p(171) =  .lblOperand(2).width
    p(172) =  .lblOperand(2).Caption 
    p(174) = web_GetVis( .cmdEnd)
    p(175) =  .cmdEnd.top
    p(176) =  .cmdEnd.left
    p(177) =  .cmdEnd.height
    p(178) =  .cmdEnd.width
    p(179) =  .cmdEnd.Caption 
    p(181) = web_GetVis( .Label6)
    p(182) =  .Label6.top
    p(183) =  .Label6.left
    p(184) =  .Label6.height
    p(185) =  .Label6.width
    p(186) =  .Label6.Caption 
    p(188) = web_GetVis( .Label5)
    p(189) =  .Label5.top
    p(190) =  .Label5.left
    p(191) =  .Label5.height
    p(192) =  .Label5.width
    p(193) =  .Label5.Caption 
    p(195) = web_GetVis( .Label4)
    p(196) =  .Label4.top
    p(197) =  .Label4.left
    p(198) =  .Label4.height
    p(199) =  .Label4.width
    p(200) =  .Label4.Caption 
    p(202) = web_GetVis( .lblSecondsDifference)
    p(203) =  .lblSecondsDifference.top
    p(204) =  .lblSecondsDifference.left
    p(205) =  .lblSecondsDifference.height
    p(206) =  .lblSecondsDifference.width
    p(207) =  .lblSecondsDifference.Caption 
    p(209) = web_GetVis( .lblTimerCalls)
    p(210) =  .lblTimerCalls.top
    p(211) =  .lblTimerCalls.left
    p(212) =  .lblTimerCalls.height
    p(213) =  .lblTimerCalls.width
    p(214) =  .lblTimerCalls.Caption 
    p(216) = web_GetVis( .mnuFile)
    p(218) =  .mnuFile.Caption 
    p(221) = web_GetVis( .mnuNew)
    p(223) =  .mnuNew.Caption 
    p(225) = web_GetVis( .mnuSelectWork)
    p(227) =  .mnuSelectWork.Caption 
    p(230) = web_GetVis( .mnuCalculator)
    p(232) =  .mnuCalculator.Caption 
    p(234) = web_GetVis( .mnuHelp)
    p(236) =  .mnuHelp.Caption 
    p(239) = web_GetVis( .mnuHelpMenu)
    p(241) =  .mnuHelpMenu.Caption 
    p(243) = web_GetVis( .mnuAbout)
    p(245) =  .mnuAbout.Caption 
    p(247) = web_GetVis( .mnuTest)
    p(249) =  .mnuTest.Caption 

  End With
  web_d "Got properties."
End Sub
