Attribute VB_Name = "TextBoxBuffer"
Option Explicit
'Private LastSelStartPosition&
Private InfoNormalized As Boolean
Public tbuff_d_TextButtonsLocked As Boolean
Public PositionForPageDown&, PositionForPageUp&

Public Function CheckDoWeOnTheFirstString&(targettext$, CurrentPosition&)
Dim wi&
wi = FindFirstString&(targettext$)
CheckDoWeOnTheFirstString = -1
If CurrentPosition <= wi Then CheckDoWeOnTheFirstString = Len(targettext)
End Function

'DESC:  returns TextLength if on the last line;
'       "otherwise," returns -1;
'
Public Function CheckDoWeOnTheLastString&(targettext$, CurrentPosition&)
Dim wi&
wi = FindLastString&(targettext$)
CheckDoWeOnTheLastString = -1
If CurrentPosition >= wi Then CheckDoWeOnTheLastString = Len(targettext)
End Function

'OUTPUT: returns vl-restrinctor of the first string position or len+1;
'
'
Public Function FindFirstString&(targettext$)
Dim wi&
wi = InStr(targettext, vl)
If wi = 0 Then wi = Len(targettext) + 1
FindFirstString = wi
End Function




'DESC: returns beginning of the last string;
'
'
Public Function FindLastString&(targettext$)
Dim wi&
wi = InStrRev(targettext, vl)
If wi = 0 Then wi = 1
FindLastString = wi
End Function

Public Sub tbuff_CorrectInfoIfPositionChanged(txtobj As TextBox, TextEscape$, CharRange$)
'If txtobj.SelStart <> LastSelStartPosition Then
'   tbuff_NormInfoAndDisp txtobj, TextEscape$, CharRange$
'End If
End Sub

'DESC: This make "preliminary" check: are we on fragment boundaries
'      or not. Consequent Key_UP proc. will complete the job and
'      display true information.
'
Public Sub tbuff_Key_DOWN(txtobj As TextBox, FileText$, TextEscape$, CharRange$, KeyCode As Integer, Shift As Integer)
Dim wi&
If tbuff_d_TextButtonsLocked Then Exit Sub

With txtobj

'LastSelStartPosition = .SelStart

If Shift = 2 Then
   PositionForPageDown = 0
   PositionForPageUp = 0
   Select Case KeyCode
          Case 34:  txtobj.SelStart = Len(txtobj.Text)                           'ctr+page down
                    tbuff_NormAndDisp txtobj, FileText, TextEscape$, CharRange$, 0, True
          Case 33:  txtobj.SelStart = 0                                          'ctr+page up
                    tbuff_NormAndDisp txtobj, FileText, TextEscape$, CharRange$, 0, True
          Case 35:                                                               'ctrl + end
                    tbuff_NormAndDisp txtobj, FileText, TextEscape$, CharRange$, 2, True   '2-to the end
          Case 36:  tbuff_NormAndDisp txtobj, FileText, TextEscape$, CharRange$, 1, True  '1-to the beginning
   End Select
   GoTo SubEnd
End If


Select Case KeyCode
    Case 40, 34   'arrow,page down
      PositionForPageUp = 0
      wi = CheckDoWeOnTheLastString(.Text, .SelStart)
      If (wi > -1 And txtobj.SelStart > Len(txtobj.Text) - 160) Or _
          txtobj.SelStart + 1 = PositionForPageDown Then
        '160 - to benefit binaries.
        tbuff_NormAndDisp txtobj, FileText, TextEscape$, CharRange$, 0, True
        PositionForPageDown = 0
      Else
        PositionForPageDown = txtobj.SelStart + 1
      End If
    Case 38, 33 'arrow,page up
      PositionForPageDown = 0
      wi = CheckDoWeOnTheFirstString(.Text, .SelStart)
      If (wi > -1 And txtobj.SelStart < 160) Or _
          txtobj.SelStart + 1 = PositionForPageUp Then
        'for not too very long strings. If string is too long,
        'then this feature disabled to benefit binaries:
        tbuff_NormAndDisp txtobj, FileText, TextEscape$, CharRange$, 0, True
        PositionForPageUp = 0
      Else
        PositionForPageUp = txtobj.SelStart + 1
      End If
  
    Case 39         '"arrow to the rigth" at the end;
      PositionForPageUp = 0
      PositionForPageDown = 0
      If .SelStart = Len(.Text) Then
        tbuff_NormAndDisp txtobj, FileText, TextEscape$, CharRange$, 0, True
      End If
    Case 37         '"arrow to the left" at the beginning;
      PositionForPageUp = 0
      PositionForPageDown = 0
      If txtobj.SelStart = 0 Then
        tbuff_NormAndDisp txtobj, FileText, TextEscape$, CharRange$, 0, True
      End If
    Case Else
      PositionForPageUp = 0
      PositionForPageDown = 0
        'I remming this out to do not shock user working
        'at the end of fragment:
        '
        'in the case of the end of string this will not work, but
        '"line down" should be used by user:
        'If .SelStart < Len(.Text) - 5 Then
        '   wi = CheckDoWeOnTheLastString(.Text, .SelStart)
        '   If wi > -1 Then
        '      tbuff_NormAndDisp txtObj, FileText, TextEscape$, CharRange$, 0, True
        '   End If
        'End If
End Select
End With

SubEnd:
End Sub

'mirror for speed:
Public Sub tbuff_Key_UP(txtobj As TextBox, FileText$, TextEscape$, CharRange$, KeyCode As Integer, Shift As Integer)
Dim wi&
If tbuff_d_TextButtonsLocked Then Exit Sub

InfoNormalized = False

With txtobj
'If Shift = 2 Then
'   Select Case KeyCode
'          Case 34:  txtObj.SelStart = Len(txtObj.Text)                           'ctr+page down
'                    tbuff_NormAndDisp txtObj, FileText, TextEscape$, CharRange$, 0, True
'          Case 33:  txtObj.SelStart = 0                                          'ctr+page up
'                    tbuff_NormAndDisp txtObj, FileText, TextEscape$, CharRange$, 0, True
'          Case 35:                                                               'ctrl + end
'                    tbuff_NormAndDisp txtObj, FileText, TextEscape$, CharRange$, 2, True   '2-to the end
'          Case 36:  tbuff_NormAndDisp txtObj, FileText, TextEscape$, CharRange$, 1, True  '1-to the beginning
'   End Select
'   GoTo SubEnd
'End If

'for case shift + insert:
If Len(.Text) > TextBoxRestriction Then
   tbuff_NormAndDisp txtobj, FileText, TextEscape$, CharRange$, 0, True
   GoTo SubEnd
End If
   

Select Case KeyCode
    Case 40, 34   'arrow,page down
      'wi = CheckDoWeOnTheLastString(.Text, .SelStart)
      'If wi > -1 Then
      '  tbuff_NormAndDisp txtObj, FileText, TextEscape$, CharRange$, 0, True
      'End If
    Case 38, 33 'arrow,page up
      'wi = CheckDoWeOnTheFirstString(.Text, .SelStart)
      'If wi > -1 Then
      '  tbuff_NormAndDisp txtObj, FileText, TextEscape$, CharRange$, 0, True
      'End If
    Case 39         '"arrow to the rigth" at the end;
      'If .SelStart = Len(.Text) Then
      '  tbuff_NormAndDisp txtObj, FileText, TextEscape$, CharRange$, 0, True
      'End If
    Case 37         '"arrow to the left" at the beginning;
      'If txtObj.SelStart = 0 Then
      '  tbuff_NormAndDisp txtObj, FileText, TextEscape$, CharRange$, 0, True
      'End If
    Case Else
        'in the case of the end of string this will not work, but
        '"line down" should be used by user:
        'If .SelStart < Len(.Text) - 5 Then
        '   wi = CheckDoWeOnTheLastString(.Text, .SelStart)
        '   If wi > -1 Then
        '      tbuff_NormAndDisp txtObj, FileText, TextEscape$, CharRange$, 0, True
        '   End If
        'End If
End Select
End With

SubEnd: If Not InfoNormalized Then
           tbuff_NormInfoAndDisp txtobj, TextEscape$, CharRange$
        End If

End Sub

Public Sub tbuff_LoadNewText(txtobj As TextBox, FileText$, _
                             TextEscape$, CharRange$)
txtobj.Tag = "1:0:" & Len(FileText) & ":0:0"
txtobj.Text = ""
tbuff_NormAndDisp txtobj, FileText, TextEscape, CharRange, 1, True
End Sub

'INPUT:  txtObj
'        SavedFileText
'        no: FullLength for fresh file.
'
'OUTPUT: former(before box editing) window inside the former SavedFileText: WStart:WEnd
'        WGlobalPosition in true (new text (which is not normalized yet)
'        WSelectStart which is current pos in box if it would be unescaped.
'        UnescapedText - obvious.
'        FullLength    - true (updated length)
'        WLinesBefore  - lines in text-part before box
'
Public Sub tbuff_Norm_Info( _
       txtobj As TextBox, UnpritableCharEscape$, CharRange$, WStart&, WWEnd&, WGlobalPosition&, _
       WSelectStart&, UnescapedText$, FullLength&, WLinesBefore&, _
       CountedBefore&)

Dim wi&, WTag$, WUneditedFullLength&

WSelectStart = txtobj.SelStart
If CharRange = "" Then
   UnescapedText = txtobj.Text
Else
   UnescapedText = asc_UT(txtobj.Text, UnpritableCharEscape, CharRange, WSelectStart)
End If
WTag = txtobj.Tag
'kk.do2 strange Xc at startup:
'redundant: must never happen:
If "" = WTag Then
   'This happens at start up: why?
   'MsgBox "Empty tag in " & txtobj.Name
   WTag = "1:0:" & CStr(FullLength) & ":0:0" 'this is a protection;
   'Probably this helps:
   'tbuff_LoadNewText(txtobj
   '
   'txtobj.Tag = "1:0:" & Len(FileText) & ":0:0"
   'txtobj.Text = ""
   'tbuff_NormAndDisp txtobj, FileText, TextEscape, CharRange, 1, True
End If

'If WTag = "" Then WTag = "1:0:" & CStr(FullLength) & ":0:0" 'this is a protection;
'Wstart:Wend:UenditedLength:LinesBefore
'if txtObj.Text = "" or UnEscapedText = "" then WSelectStart=0
       
'===============================================
'parse tag:
'-----------------------------------------------
Dim SplittedTag
SplittedTag = Split(WTag, ":")
'wi = InStr(WTag, ":")
WStart = CLng(SplittedTag(0))
WWEnd = CLng(SplittedTag(1))
WUneditedFullLength = CLng(SplittedTag(2))
WLinesBefore = CLng(SplittedTag(3))
CountedBefore = CLng(SplittedTag(4))
'===============================================

WGlobalPosition = WStart - 1 + WSelectStart
wi = WWEnd - WStart + 1   'former("undedited") length of displayed text.
FullLength = WUneditedFullLength + Len(UnescapedText) - wi

End Sub


'INPUT:  par_GlobalPosition = 0, then normal operation,
'                           = 1, set to the beginning,
'                           = 2, set to the end
'        txtObj.tag;        which inputs box-text and tab:
'                           if tab X:Y
'                           X - position on which box-cut starts or 1 if file = ""
'                           X must be always >=1
'                           Y - position on which box-cut ends; Y >=0
'        FileText
'
'
'INPUT FROM GLOBALS:
'        Public CharRange$
'        UnpritableCharEscape$  Both must be set to a right control.
'
'
Public Sub tbuff_NormAndDisp( _
       txtobj As TextBox, FileText$, TextEscape$, CharRange$, par_GlobalPosition&, _
       NormalizeInfo As Boolean)
Dim WSelectStart&, WStart&, WWEnd&
Dim WSecondPart$
Dim WGlobalPosition&
Dim UnescapedText$
Dim File_Length&
Dim CountedBefore&, LinesBefore&, WSelectStartInBox&

ssmain.UserWaitWarning

tbuff_Norm_Info txtobj, TextEscape, CharRange, WStart, WWEnd, WGlobalPosition, _
                    WSelectStart, UnescapedText, File_Length, LinesBefore, CountedBefore

'===============================================
'  FIRST PART: file text is restored
'  (after edition) from text box.
'-----------------------------------------------
If WWEnd < Len(FileText) Then
   WSecondPart = Mid(FileText, WWEnd + 1)
Else
   WSecondPart = ""
End If
'save edited text:
FileText = Left(FileText, WStart - 1) & UnescapedText & WSecondPart
'===============================================

          
          
'=========================================================================
'SECOND PART: PUTTING FILE INTO BOX BACK.
'WGlobalPosition is ready now.
'analyse text size and current position,
'split text is needed, and
'retrun (only portion if splitted) text to the box:
'-------------------------------------------------------------------------
'retrieve a new portion of text from master text:
'calculate global position:

Dim ShortDisplayLength&
ShortDisplayLength = 3 'decrease ... if text is escaped:
If Len(CharRange) <> 0 Then ShortDisplayLength = 9

If par_GlobalPosition > 0 Then
   If par_GlobalPosition = 1 Then
      'move up to top:
      WGlobalPosition = 0
      WStart = 1
      WWEnd = TextBoxRestriction * 2 / ShortDisplayLength
   Else
      WGlobalPosition = File_Length
      WWEnd = WGlobalPosition
      WStart = WGlobalPosition - (TextBoxRestriction * 2 / ShortDisplayLength)
   End If
Else
   'calculate new view frame: WStart and WWEnd:
   WStart = WGlobalPosition - (TextBoxRestriction / ShortDisplayLength)
   WWEnd = WGlobalPosition + (TextBoxRestriction / ShortDisplayLength)
End If

If WStart < 1 Then WStart = 1
If WWEnd > File_Length Then WWEnd = File_Length


'=================================================================================
'  wstart and wend is all we need now.
'  they are completely ready now.
'---------------------------------------------------------------------------------
'  to "absorb" cr if in combination with lf and fragment boundary is between them:
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
If WStart > 1 Then
   If Mid(FileText, WStart, 1) = vbLf And Mid(FileText, WStart - 1, 1) = vbCr Then
      WStart = WStart - 1
   End If
End If
If WWEnd < File_Length Then
   If Mid(FileText, WWEnd, 1) = vbCr And Mid(FileText, WWEnd + 1, 1) = vbLf Then
      WWEnd = WWEnd + 1
   End If
End If
'---------------------------------------------------------------------------------

'WGlobalPosition ~ WSelStart is a char number which is before cursor:
WSelectStart = WGlobalPosition - WStart + 1
If WSelectStart < 0 Then WSelectStart = 0
If WSelectStart > Len(UnescapedText) Then WSelectStart = Len(UnescapedText)

'take text and set SelStart:
'make new UnescapedText:
UnescapedText = Mid(FileText, WStart, WWEnd - WStart + 1)

'==================================================================================
'protect binary files:
If InStr(UnescapedText, Chr(0)) > 0 And InStr(CharRange, Chr(0)) = 0 Then _
   CharRange = CharRange & Chr(0)
If InStr(CharRange, vbCr) = 0 Then
   'Protect against single cr-s:
   'kk.15.2 fix: UnescapedText.
   If FindSingleCR(UnescapedText) Then CharRange = CharRange & vbCr & vbLf
End If
'==================================================================================


WSelectStartInBox = WSelectStart

If CharRange = "" Then
   txtobj.Text = UnescapedText
Else
   txtobj.Text = asc_T(UnescapedText, TextEscape$, CharRange$, "A", WSelectStartInBox)
End If
txtobj.SelStart = WSelectStartInBox

LinesBefore = CountOccurances(Left(FileText, WStart - 1), vbLf, CountedBefore) + 1
txtobj.Tag = CStr(WStart) & ":" & CStr(WWEnd) & ":" & File_Length & ":" & LinesBefore & ":" & CountedBefore
'=========================================================================
    
'=========================================================================
' DISPLAY BLOCK
If NormalizeInfo Then
   tbuff_Paint UnescapedText, TextEscape, CharRange, WSelectStart, WStart&, WWEnd&, _
                          File_Length, WGlobalPosition + 1, _
                          LinesBefore, CountedBefore
   InfoNormalized = True
End If
'=========================================================================

ssmain.UserDontWait
End Sub



Public Sub tbuff_NormInfoAndDisp(txtobj As TextBox, TextEscape$, CharRange$)
Dim WStart&, WWEnd&, WGlobalPosition&, WSelectStart&, UnescapedText$, File_Length&
Dim CountedBefore&, LinesBefore&

ssmain.UserWaitWarning
tbuff_Norm_Info txtobj, TextEscape$, CharRange$, WStart, WWEnd, WGlobalPosition, _
                    WSelectStart, UnescapedText, File_Length, LinesBefore, CountedBefore
                    
                    
tbuff_Paint UnescapedText, TextEscape$, CharRange$, WSelectStart, WStart, WWEnd, _
                    File_Length, WGlobalPosition + 1, _
                    LinesBefore, CountedBefore
ssmain.UserDontWait

End Sub









Public Sub tbuff_NormalizeWhenBig(txtobj As TextBox, FileText$, TextEscape$, CharRange$)
If tbuff_d_TextButtonsLocked Then Exit Sub

If Len(txtobj.Text) > TextBoxRestriction Then
   tbuff_NormAndDisp txtobj, FileText, TextEscape$, CharRange$, 0, True
Else
   tbuff_NormInfoAndDisp txtobj, TextEscape$, CharRange$
End If
End Sub

'DESC: sorry, this needs UnescapedText.
'      WSelectStart& - clean=unescaped.
'
Public Sub tbuff_Paint(UnescapedText$, UnpritableCharEscape$, CharRange$, WSelectStart&, WStart&, WWEnd&, _
       File_Length&, WGlobal&, LinesBefore&, CountedBefore&)
       
Dim OccurancesInBox&, CountedTotal&, Counted&
Dim WBoxTextSize&
Dim MaxSize&

OccurancesInBox = CountOccurances(Left(UnescapedText, WSelectStart), vbLf, Counted)
If OccurancesInBox = 0 Then
      CountedTotal = CountedBefore
      'LinesBefore  unchanged
Else
      CountedTotal = Counted + WStart - 1
      LinesBefore = LinesBefore + OccurancesInBox
End If
   
ssmain.txtPositionInLine.Text = WGlobal - CountedTotal
ssmain.txtLines.Text = LinesBefore

WBoxTextSize = WWEnd - WStart + 1

If WBoxTextSize = File_Length Or Len(UnescapedText) = File_Length Then
   ssmain.picScroll.Visible = False
   GoTo SkippedPicScroll
End If

'========================================================================
ssmain.picScroll.Visible = True
MaxSize = ssmain.picScroll.Height
With ssmain.shpScroll
.Width = ssmain.picScroll.Width - 70
If File_Length = 0 Then
   .Top = 0 'ssmain.picScroll.Top
   .Height = MaxSize
Else
  '.Top = ssmain.picScroll.Top + MaxSize * (WStart - 1) / File_Length
  .Top = CDbl(MaxSize) * (WStart - 1) / File_Length
  .Height = CDbl(MaxSize) * WBoxTextSize / File_Length
End If
If .Top > MaxSize - 150 Then
   .Top = MaxSize - 150
   .Height = 150
End If
If .Height < 50 Then .Height = 50
End With
'========================================================================


SkippedPicScroll:
If CharRange <> "" Then
   ssmain.lblEscaped.Visible = True
   ssmain.lblEscaped.Caption = UnpritableCharEscape
Else
   ssmain.lblEscaped.Visible = False
End If

With ssmain
.txtGlobalPosition.Text = WGlobal
.txtLines.Visible = True
.txtPositionInLine.Visible = True
.txtGlobalPosition.Visible = True
.cmdSetHex.Visible = True
.lblWait.Visible = True
End With

End Sub


