VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CDiskVariables"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private var_List$

'perhaps in future for speed:
'Private var_Values$()

Private Abs_file_name$()
Private File_handler%()
Private OpenInMode$()
Private Const var_Exists$ = vbLf
Private Const var_Erased$ = vbCr

Private moPr As CPrint
Private moVr As CVariables

Public Sub SetMoVariables(vr As CVariables)
Set moVr = vr
End Sub

Public Sub SetMoPrint(pr As CPrint)
Set moPr = pr
End Sub

Private Function BuildVarName$(name_with_positions$, _
                 record_start&, record_length&)
  Dim middle_var_name$, spos$, slen$
  Dim ws$, wi&, WII&
    
  record_start = 0
  record_length = 0
    
  'first parse the name:
  wi = InStr(name_with_positions, ",")
  If 0 = wi Then
     middle_var_name = name_with_positions
     GoTo BuildName
  Else
     middle_var_name = Left(name_with_positions, wi - 1)
  End If
  
  On Error GoTo he
   
  WII = InStr(wi + 1, name_with_positions, ",")
  If WII <> 0 Then
     spos = Mid(name_with_positions, wi + 1, WII - wi - 1)
     slen = Mid(name_with_positions, WII + 1)
  Else
     spos = Mid(name_with_positions, wi + 1)
  End If
 
  
  If 0 <> Len(spos) Then
     wi = Asc(Left(spos, 1))
     If wi < 48 Or wi > 57 Then
        'pos is a variable number:
        'fe: ..put$pos$$variable,3,my$var."VALUE"
        record_start = CLng(moVr.var_Get(spos))
     Else
        'pos is a plain number:
        'fe: ..put$var,3,my$var."VALUE"
        record_start = CLng(spos)
     End If
  End If
        
  If 0 <> Len(slen) Then
     wi = Asc(Left(slen, 1))
     If wi < 48 Or wi > 57 Then
        record_length = CLng(moVr.var_Get(slen))
     Else
        record_length = CLng(slen)
     End If
  End If
 
 
BuildName:
  'use tools from general variable programs:
  BuildVarName = moVr.var_BuildVarName(middle_var_name)
  
  Exit Function
  
he:
  ws = CStr(Err.Number) & " " & Err.Description & _
       ve & "When parsing disk-variable name: " & ve & _
       name_with_positions
  On Error GoTo 0
  e_raise ws
  
End Function

'EXCE free
'
Public Function CloseAllVariables()
  Dim ListLen$, var_name$, I&
  
  'This will help to avoid messages
  'at application termination:
  On Error Resume Next
  
  ListLen = Len(var_List) \ 33

  For I = 2 To ListLen
      var_name = Mid(var_List, 33 * (I - 1) + 2, 32)
      If var_Erased <> Left(var_name, 1) Then
         moPr.PrintL ve & "Closing file " & _
            Abs_file_name(I - 1) & _
            " for variable """ & var_name & """"
         CloseVariable (var_name)
      End If
  Next
  
End Function

Public Sub CloseVariable(var_name$)
  Dim var_ind&, ws$
  
  On Error GoTo he
  
  var_ind = GetIndexNotCreate(var_name)
  If 0 = var_ind Then _
     e_raise "Cannot close disk-variable " & _
             var_name & _
             ve & " because it does not exist."
             
  'close the file:
  Close File_handler(var_ind)
  Abs_file_name(var_ind) = ""
  File_handler(var_ind) = -1
  OpenInMode(var_ind) = ""
  
  'erase variable name from list:
  Mid(var_List, var_ind * 33 + 1, 33) = _
      var_Exists & var_Erased & Space(31)
  Exit Sub
     
he:
   'exc. are warn, text_stop=e_rase=E_think
   ws = CStr(Err.Number) & " " & _
        Err.Description & ve & _
        "When closing disk-variable " & _
        var_name
   On Error GoTo 0
   e_raise CStr(ws)

End Sub

Public Function GetVar$(full_var_name$)
  Dim record_pos&, record_length&, var_name$
  Dim var_ind&, ws$
  Dim WHandler%
  Dim wlength&
  Dim WTopRequest&
      
  var_name = BuildVarName(full_var_name, _
             record_pos, record_length)
  var_ind = GetIndexNotCreate(var_name)
  
  'make this silently, let user
  'to worry why ...
  If 0 = var_ind Then Exit Function
  
  On Error GoTo he
  
  If record_length < 1 Then record_length = 1
  WHandler = File_handler(var_ind)
  wlength = LOF(WHandler)
  
  If record_pos < 1 Then record_pos = Seek(WHandler)
  
  If record_pos > wlength Then
     ws = ""
  Else
     WTopRequest = record_pos + record_length - 1
     If WTopRequest > wlength Then _
        record_length = wlength - record_pos + 1
     If record_length < 1 Then
        ws = ""
     Else
        ws = Space(record_length)
        Get WHandler, record_pos, ws
     End If
  End If
  GetVar = ws
  
  Exit Function

he:
   'exc. are warn, text_stop=e_rase=E_think
   ws = CStr(Err.Number) & " " & _
        Err.Description & ve & _
        "When reading disk-variable " & _
        var_name
   On Error GoTo 0
   e_raise CStr(ws)
  
End Function


Public Sub OpenFileLen(name_with_positions$)
  Dim var_ind&, ws$, wi&
  Dim var_name$, assignee_name$
  
  'first parse the name:
  wi = InStr(name_with_positions, ",")
  If 0 = wi Then
     var_name = name_with_positions
     assignee_name = ""
  Else
     var_name = Left(name_with_positions, wi - 1)
     assignee_name = Mid(name_with_positions, wi + 1)
  End If
  
  On Error GoTo he
  var_ind = GetIndexNotCreate(var_name)
  If 0 = var_ind Then
     ws = "0"
  Else
     ws = CStr(LOF(File_handler(var_ind)))
  End If
  moVr.var_Set assignee_name, ws
  
  Exit Sub
     
he:
   'exc. are warn, text_stop=e_rase=E_think
   ws = CStr(Err.Number) & " " & _
        Err.Description & ve & _
        "When taking length of open file: " & _
        var_name
   On Error GoTo 0
   e_raise CStr(ws)

End Sub

Public Sub OpenVariable(middle_var_name$, Abs_FileName$, HowOpen$)
  Dim var_index&, var_name$, ws$
  On Error GoTo he
  
  var_name = moVr.var_BuildVarName(middle_var_name)
  var_index = GetIndexNotCreate(var_name)
  If 0 <> var_index Then CloseVariable var_name
  
  'some part is redundant:
  var_index = GetIndexMayCreate(var_name)
  
  Abs_file_name(var_index) = Abs_FileName
  File_handler(var_index) = FreeFile
  
  OpenInMode(var_index) = HowOpen
  Select Case HowOpen
     Case "R"
          Open Abs_FileName For Binary _
            Access Read _
            As File_handler(var_index)
     Case "W"
          Open Abs_FileName For Binary _
            Access Write _
            Lock Write _
            As File_handler(var_index)
     Case "O"
          Open Abs_FileName For Binary _
            Access Read Write _
            Lock Read Write _
            As File_handler(var_index)
  End Select
  Exit Sub

he:
   'exc. are warn, text_stop=e_rase=E_think
   ws = CStr(Err.Number) & " " & _
        Err.Description & ve & _
        "When opening disk-variable " & _
        var_name & " on file " & ve & _
        Abs_FileName
   On Error GoTo 0
   e_raise CStr(ws)
  
End Sub


'EXCE free
'
'DESC VName must be well-defined.
'     If var does not exist, zero is returned.
Public Function GetIndexNotCreate&(VName$)
  Dim VSearch$, VPosition&
  VSearch = Space(33)
  LSet VSearch = var_Exists & VName
  GetIndexNotCreate = CLng(InStr(var_List, VSearch) / 33)
End Function


Public Sub PutVar(full_var_name$, var_value$)
  Dim var_name$, record_pos&, rec_len&
  Dim var_ind&, ws$
    
  On Error GoTo he
  
  var_name = BuildVarName(full_var_name, _
             record_pos, rec_len)
  var_ind = GetIndexNotCreate(var_name)
  
  'make this silently,
  'let user to worry why ...
  If 0 = var_ind Then Exit Sub
  
  'perhaps "screen-project" and no
  'permissions to write:
  Select Case OpenInMode(var_ind)
     Case "P", "R": Exit Sub
  End Select
  
  If rec_len > 0 Then _
     var_value = Left(var_value, rec_len)
  If 0 = record_pos Then
     Put File_handler(var_ind), , var_value
  Else
     Put File_handler(var_ind), _
         record_pos, var_value
  End If
  
  Exit Sub

he:
   'exc. are warn, text_stop=e_rase=E_think
   ws = CStr(Err.Number) & " " & _
        Err.Description & ve & _
        "When writing to disk-variable " & _
        var_name
   On Error GoTo 0
   e_raise CStr(ws)

End Sub

Private Sub Class_Initialize()
 ReDim Abs_file_name(0)
 ReDim File_handler(0)
 ReDim OpenInMode(0)
 'make the first line empty
 'to simplify formula of index:
 'ind = InStr/33:
 var_List$ = Space(33)
End Sub



'DESC VName must be well defined and checked.
'     The only proc which creates new var.
'     Returned index is always well defined and > 0.
'
'NOTE Don't be confused here: VPosition has two
'     meanings here: as Index and as Position in var_List.
'     This dirty code must be cleaned.
'
Public Function GetIndexMayCreate&(VName$)
Dim VSearch$, ws$, VPosition&

VSearch = Space(33)
LSet VSearch = var_Exists & VName
VPosition = CLng(InStr(var_List, VSearch) / 33)

If VPosition > 0 Then
   GetIndexMayCreate = VPosition
   Exit Function
End If
   
'var is not found:
ws = Space(33) 'String(33, Chr(10)) ' Space(33)
LSet ws = var_Exists & VName
   
'for the future:
'seach for gabls in variable list;
'gab flag is var_Erased;
VPosition = InStr(var_List, var_Exists & var_Erased)
If VPosition = 0 Then
      
      'THE ONLY PLACE WHRE NEW SLOT FOR VARIABLE
      '    IS ADDED:
      'no empty space: current version:
      'add space to both array and the list;
      VPosition = UBound(Abs_file_name) + 1
      var_List = var_List & ws
      ReDim Preserve OpenInMode(VPosition)
      ReDim Preserve Abs_file_name(VPosition)
      ReDim Preserve File_handler(VPosition)
             
Else
      
      'an empty space is found:
      'fill this gab:
      Mid(var_List, VPosition) = ws
      VPosition = CLng(VPosition / 33)
       
End If

GetIndexMayCreate = VPosition

End Function


Private Sub Class_Terminate()
  CloseAllVariables
  Set moPr = Nothing
  Set moVr = Nothing
End Sub


