Attribute VB_Name = "UAConstantsAPI"
Option Explicit

'=================================================================================
' SCHEMA ALPHABET
'---------------------------------------------------------------------------------
'Internal; not forbidden chars in query string:
Public Const ialph__AbsStateEsc As String = "A"          'Absolute state position.

Public Const salph__StateEsc As String = "="
Public Const salph__ShiftUp As String = ">"
Public Const salph__ShiftDown As String = "<"
Public Const salph__Event As String = "+"
Public Const salph__Late_Event As String = "*"
Public Const salph__Immidiate As String = "|"
Public Const salph__Action As String = ":"
Public Const salph__Comment As String = "'"
Public Const salph__ClusterSeparator As String = "."
Public Const salph__StateSeparator As String = ","

Public Const alph__Variable As String = "$"
Public Const alph__EscInText As String = "\"
Public Const alph__TextStartedSignal As String = """"

Public Const env_EnterSchema As String = "\\"  'Marks beginning of schema.
'---------------------------------------------------------------------------------
' SCHEMA ALPHABET
'=================================================================================


'*********************************************************************************
'       STATE
'---------------------------------------------------------------------------------
'   WHEN MODIFYING, DO NOT FORGET TO UPDATE PROC "init_NamesArrayForReservedStates"
'---------------------------------------------------------------------------------
Public Const s__$ = "-"                     '"any state"
Public Const si__& = 1

Public Const s__Many$ = "*"
Public Const si__Many& = 2

Public Const s__Root$ = "-r"
Public Const si__Root& = 3

Public Const s__Schema$ = "-schema"
Public Const si__Schema& = 4

Public Const s__Statement$ = "-s"
Public Const si__Statement& = 5

Public Const s__Any$ = "-a"                 'index is already done: 1

Public Const s__Non_Specified$ = "-n"
Public Const si__Non_Specified& = 6
Public Const si_TotalDefaults& = 6

'---------------------------------------------------------------------------------
'       STATE
'*********************************************************************************





'IN THIS DECLARATION SECTION, ONLY CONSTANTS ARE APPEARS BELOW NOW (rev. 16_8)

'*********************************************************************************
'           ACTION
'=================================================================================

'=================================================================================
'CONTROLS AND COMMANDS: case-sensitive:
'  CR - seems stands for compile and run - time:
Public Const aCRP__END_TEXT$ = "end"
Public Const aCRP__END_TEXT2$ = "end_text"
Public Const aCRP__STOP$ = "stop"
'=================================================================================

'=================================================================================
'IMMEDIATE COMMANDS only; case-sensitive:
'---------------------------------------------------------------------------------
Public Const aC__BEGIN_PROGRAM$ = "program"
Public Const aC__END_PROGRAM$ = "end_program"
'=================================================================================

'=================================================================================
'CONTROLS:
'---------------------------------------------------------------------------------
Public Const aR__STREAM_ON$ = "+"
Public Const aR__STREAM_OFF$ = "-"
Public Const aR__STREAM_ON_AND_EMPTY$ = "*"

Public Const aR__NONE$ = "n"   'needed when statement-mask is "+:"
Public Const aR__OUTPUT_TO_CONSOLE$ = "~"
Public Const aR__OUTPUT_TOKEN$ = "&"
Public Const aR__PRINT_TOKEN$ = "&&"
Public Const aR__ASSIGN_TO_VARIABLE$ = "="

Public Const aR__COMPILE_SCHEMA$ = "compile_schema"
Public Const aR__COMPILE_PROJECT$ = "compile_project"
Public Const aR__PROGRAM$ = "p"     'make pr if too complex;

Public Const aR__INDENT$ = "i"
Public Const aR__CHAR$ = "char"
Public Const aR__BYTE$ = "byte"     'take one byte from current position;
Public Const aR__2CHARS$ = "2chars" 'take 2 chars long word from current position;
Public Const aR__UPTO$ = "upto"

Public Const aR__WORD$ = "word"
Public Const aR__BWORD$ = "bword"
Public Const aR__BLWORD$ = "blword"
Public Const aR__LWORD$ = "lword"
Public Const aR__TAKE_STRING$ = "str"

'=================================================================================
'   ARITHMETICAL AND OTHER COMMANDS
Public Const alph__ListVariableOperation$ = "~"
'other are not "macrosed" yet


'   LIST OPERATION ESCAPES:
Public Const alph__ListVariableEscape$ = "^"
Public Const alph__ListVariableSeparator$ = vbLf
Public Const alph__ListVariableHiddenSeparator$ = "\"
'=================================================================================


'ACTION-COMMANDS including SWITCHES
Public Const aCP__RESTART_PROJECT$ = "restart_project"  'in effect only at the end of project.

Public Const aCP__SAVE_FILE_MODE$ = "save_file_mode"
Public Const aCP__BLOCK_HTMLENCODING$ = "block_html_encoding"
Public Const aCP__ClearGlobalQueue$ = "clear_global_queue"
Public Const aCP__SUSPEND$ = "suspend"
Public Const aCP__DEBUG$ = "debug"
Public Const aCP__DDEBUG$ = "ddebug"

Public Const aCP__HELP$ = "help"
Public Const aCP__HELP2$ = "?"
Public Const aCP__PDEBUG$ = "pdebug"
Public Const aCP_TOKENS_CASE_SENSETIVE$ = "tokens_case_sensetive"

'----------------------------------------------------------------------------------
'USER-COMMANDS TO CHANGE ENVIRONMENT: case-sensitive: usually need parameter;
Public Const aCP__EVENT_STATEMENT_MASK$ = "event_statement_mask"  'not done yet;
Public Const aCP__TOKENIZER_RECONIZES_QUOTED_STRINGS$ = "recongnize_strings"
Public Const aCP__BASIC_ENVIRONMENT$ = "percept"


Public Const aCP__SEPARATORS_ARE_GLOBAL$ = "separators_are_global"
Public Const aCP__SKIP_PROJECT$ = "skip_project"

Public Const aCP__NATIVE_SEPARATORS$ = "native_separators"
Public Const aCP__no_change_outside_result$ = "no_change_outside_result"
Public Const aCP__RECOGNIZE_NUMBERS$ = "recognize_numbers"

Public Const aCP__WORD_CASE_SENSETIVE$ = "word_case_sensetive"
Public Const aCP__AllowOrphanStates$ = "allow_orphan_states"

Public Const aCP__KEYWORD_CASE_SENSETIVE$ = "keyword_case_sensetive"
Public Const aCP__SEPARATOR_CASE_SENSETIVE$ = "separator_case_sensetive"
Public Const aCP__MAKE_INDENT_AT_EACH_STATE$ = "make_indent_at_each_state"
Public Const aCP__each_char_is_separator$ = "each_char_is_separator"
Public Const aCP__OUTPUT_CASE$ = "output_case"

Public Const aCP__OUTPUT_TEXT_TO_CONSOLE$ = "output_text_to_console"
Public Const aCP__TZ_STRIP_QMARKS$ = "tz_strip_qmarks"
Public Const aCP__TZ_CONV_STR$ = "tz_conv_str"

Public Const aCP__TZ_WORD_CASE$ = "tz_word_case"
Public Const aCP__TZ_SEPARATOR_CASE$ = "tz_separator_case"
Public Const aCP__TZ_ID_CASE$ = "tz_id_case"
Public Const aCP__TZ_KEYWORD_CASE$ = "tz_keyword_case"
Public Const aCP__TZ_STRING_CASE$ = "tz_string_case"

Public Const aCP__INDENT_BODY$ = "indent"
'ef USER-COMMANDS TO CHANGE ENVIRONMENT:
'*********************************************************************************



'=================================================================================
'       EVENT TYPES
'---------------------------------------------------------------------------------
Public Const e__IDENTIFICATOR$ = "id"
Public Const e__SEPARATOR$ = "s"             'if motz.env_separators_are_global then global;

Public Const e__NUMBER$ = "n"
Public Const e__WORD$ = "w"
Public Const e__STRING$ = "str"

Public Const e__KEYWORD$ = "k"
Public Const e__BOT$ = "bot"
Public Const e__BOP$ = "bop"
Public Const e__EOP$ = "eop"
Public Const e__EOT$ = "eot"
Public Const e__EXC$ = "exc"
Public Const e__ANY$ = "a"              'in queue: takes ev from tokenizer;
Public Const e__SKIP_TOKEN$ = "-"       'in queue: take event from tokenizer
                                        '          don't reconginize it in dialog
                                        '          don't change token
                                        '          coded as ".."
Public Const e__SKIP_RECOGNITION$ = "+" 'in queue: the same as "-" but changes token
                                        '          coded as "."
Public Const e__DEFERRED$ = "d"         'in queue: accepts current external event;
Public Const e__LIST_VARIABLE$ = "l"
Public Const e__LIST_QUESTION$ = "?"

Public Const e__global_type_GLOBAL = "g"
Public Const e__global_type_LOCAL = "l"
Public Const e__global_type_UNSPECIFIED = "u"

'cluster types:
Public Const c__PlainText$ = "p"
Public Const c__QuotedText$ = "P"
Public Const c__Variabled$ = "V"

Public Const varn_TOKEN = "token"
Public Const varn_TYPE = "type"

'---------------------------------------------------------------------------------
'       EVENT TYPES
'=================================================================================

'*********************************************************************************
'   COMMON STRUCTURES
'=================================================================================
Public Type CommonQueue
    Interaction As String
    First As String
    Second As String
    Third As String
    Fourth As String
    Numberr As Long             'used as state index when element is a state;
    StateShift As Long          'where to move along the nest before setting the state;
    FirstStatus As String       'for event, state, action
    FourthStatus As String      'for command parameter
End Type
'*********************************************************************************



Public Declare Function GetTickCount Lib "Kernel32" () As Long
