Attribute VB_Name = "FileHandler"
Option Explicit


'EXCEP free
'
'DESCR  Checks existance of folder s, and if does not exist,
'       makes folder recursively even "underlying"
'            parent folder do not exist.
'       Silently deletes files "so-named" as s.
'
Public Function MakeFolderTree$(S$)
Dim fpath$, I&, ws$

If Mid(S, 2, 1) <> ":" Then
   MakeFolderTree = "Missed "":"" when creating folder with name:" & ve & S
   Exit Function
End If

On Error Resume Next
ws = Dir(S, vbDirectory)
If Err.Number > 0 Then
   MakeFolderTree = "Exception " & Err.Number & " " & Err.Description & ve & _
                    "when checking directory: " & S
   Exit Function
End If
   
If "" <> ws Then
   If Not ((GetAttr(S) And vbDirectory) = vbDirectory) Then
      Kill S
      If Err.Number > 0 Then
         MakeFolderTree = fpath & "is a file and I cannot delete it" & ve & _
                          "when making it a folder:" & ve & _
                          "Exception " & Err.Number & " " & Err.Description
         Exit Function
      End If
   Else
     'already done
   End If
ElseIf 2 = Len(S) Then
   MakeFolderTree = "Drive " & S & " does not exist."
   Exit Function
Else
   fpath$ = separate_path(S)
   'check/create parent folder only
   'if parent > "c:":
   ws = MakeFolderTree(fpath)
   If "" <> ws Then
      MakeFolderTree = ws
      Exit Function
   End If
   MkDir S
   If Err.Number > 0 Then
      MakeFolderTree = "Exception " & Err.Number & " " & _
                       Err.Description & ve & _
                       "when creating a folder: " & S
      Exit Function
   End If
End If

End Function
'EXCEP free
'OUTPU if exception, then exc. message returned
'
Public Function MakeFolderTreeP$(ftree$, fscope$, protect As Boolean)
Dim file_name$, ws$

If "" = fscope Or (Not protect) Then
   MakeFolderTreeP = MakeFolderTree(ftree)
   Exit Function
End If

ws = OutOfScope(fscope, ftree)

If "" = ws Then
   'can eliminate:
   file_name = fileCompressName(ftree)
   MakeFolderTreeP = MakeFolderTree(file_name)
Else
   MakeFolderTreeP = ws
End If

End Function

'EXCEP free
'DESCR Saves ftext to fpath.
'      If "underlying" folders do not exist, creates them.
'      If fscope <> "" or fprotect is true, and
'         fpath is out of fscope, then
'         no new folders are created and no file writtten.
'      If no exceptions happened, then returns "", otherwise
'         returns message.
'
Public Function f_SaveProtectively$(fpath$, ftext$, _
                                    fscope$, fprotect As Boolean)
Dim path_to_parent$, OwnName$, ws$

'***********
'Changed:

'was
'path_to_parent = get_PathedParent(fpath, OwnName)
'ws = MakeFolderTreeP(path_to_parent, fscope, fprotect)
'.....
'.....


'began:
If "" <> fscope And fprotect Then

   path_to_parent = get_PathedParent(fpath, OwnName)
   ws = OutOfScope(fscope, fpath)
   If "" <> ws Then
      f_SaveProtectively = ws
      Exit Function
   End If

End If

ws = MakeFolderTree(path_to_parent)
If "" <> ws Then
   f_SaveProtectively = ws
   Exit Function
End If
       
On Error Resume Next
write_f fpath, ftext
If Err.Number > 0 Then
   f_SaveProtectively = _
     "Exception " & Err.Number & " " & Err.Description & ve & _
     "when saving file with name: " & ve & fpath
End If


End Function

'EXCE Free
'DESC If exception, returns number and message.
'
Public Function fDeleteSilently$(n$)
On Error Resume Next
Kill n
If Err > 0 Then fDeleteSilently = CStr(Err.Number) & " " & Err.Description
End Function


'EXCE free
'
'DESC slow out-of-scope estimator
'     if in-scope, returns empty string;
'     otherwise, exception message;
'
'     c:\a\x.txt and c:\x\y
'     triggers relative path = "y"
'
'
'INPUT fscope should be compressed (no ..\x\..\)
'
'
Public Function OutOfScope$(fscope$, ftree$)
Dim file_name$, ws$

If Mid(fscope, 2, 2) <> ":\" Or _
   Mid(ftree, 2, 2) <> ":\" Then
   OutOfScope = "Missed "":\"" in scope name(s):" & ve & _
                fscope & " or in " & ve & ftree
   Exit Function
End If

file_name = fileCompressName(ftree)
If "" = file_name Then
  OutOfScope = "Exceptions when compressing name: " & ve & _
                ftree
  Exit Function
End If

'if no exceptions
'- -+ +20051126OneLevelOutsideOfScope
'was:
'ws = fileMakeRelative(fscope, file_name)
'became:
ws = fileMakeRelative(fscope & "\x", file_name)
'protect from creation outside of fscope:
If InStr(ws, "..\") = 0 Then
   Exit Function
End If

OutOfScope = "Attempt to work with unit " & ftree & ve & _
             "outside of folder" & ve & fscope
   
End Function


